Index: branches/2015/dev_r5072_UKMO2_OBS_simplification/NEMOGCM/EXTERNAL/AGRIF/LIB/fortran.c
===================================================================
--- branches/2015/dev_r5072_UKMO2_OBS_simplification/NEMOGCM/EXTERNAL/AGRIF/LIB/fortran.c	(revision 5659)
+++ branches/2015/dev_r5072_UKMO2_OBS_simplification/NEMOGCM/EXTERNAL/AGRIF/LIB/fortran.c	(revision 5682)
@@ -1,23 +1,20 @@
-/* A Bison parser, made by GNU Bison 2.3.  */
-
-/* Skeleton implementation for Bison's Yacc-like parsers in C
-
-   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003, 2004, 2005, 2006
-   Free Software Foundation, Inc.
-
-   This program is free software; you can redistribute it and/or modify
+/* A Bison parser, made by GNU Bison 2.7.  */
+
+/* Bison implementation for Yacc-like parsers in C
+   
+      Copyright (C) 1984, 1989-1990, 2000-2012 Free Software Foundation, Inc.
+   
+   This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
-   the Free Software Foundation; either version 2, or (at your option)
-   any later version.
-
+   the Free Software Foundation, either version 3 of the License, or
+   (at your option) any later version.
+   
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
-
+   
    You should have received a copy of the GNU General Public License
-   along with this program; if not, write to the Free Software
-   Foundation, Inc., 51 Franklin Street, Fifth Floor,
-   Boston, MA 02110-1301, USA.  */
+   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */
 
 /* As a special exception, you may create a larger work that contains
@@ -30,5 +27,5 @@
    Bison output files to be licensed under the GNU General Public
    License without this special exception.
-
+   
    This special exception was added by the Free Software Foundation in
    version 2.2 of Bison.  */
@@ -48,5 +45,4 @@
 
 /* Bison version.  */
-#define YYBISON_VERSION "2.3"
 
 /* Skeleton name.  */
@@ -56,371 +52,22 @@
 #define YYPURE 0
 
-/* Using locations.  */
-#define YYLSP_NEEDED 0
+/* Push parsers.  */
+#define YYPUSH 0
+
+/* Pull parsers.  */
+#define YYPULL 1
+
 
 /* Substitute the variable and function names.  */
-#define yyparse fortranparse
-#define yylex   fortranlex
-#define yyerror fortranerror
-#define yylval  fortranlval
-#define yychar  fortranchar
-#define yydebug fortrandebug
-#define yynerrs fortrannerrs
-
-
-/* Tokens.  */
-#ifndef YYTOKENTYPE
-# define YYTOKENTYPE
-   /* Put the tokens into the symbol table, so that GDB and other debuggers
-      know about them.  */
-   enum yytokentype {
-     TOK_BINARY_OP = 258,
-     TOK_NEQV = 259,
-     TOK_EQV = 260,
-     TOK_XOR = 261,
-     TOK_OR = 262,
-     TOK_AND = 263,
-     TOK_NOT = 264,
-     TOK_NE = 265,
-     TOK_EQ = 266,
-     TOK_GE = 267,
-     TOK_LE = 268,
-     TOK_GT = 269,
-     TOK_LT = 270,
-     TOK_UNARY_OP = 271,
-     TOK_DSLASH = 272,
-     TOK_SLASH = 273,
-     TOK_DASTER = 274,
-     TOK_SEP = 275,
-     TOK_SEMICOLON = 276,
-     TOK_NEXTLINE = 277,
-     TOK_PARAMETER = 278,
-     TOK_RESULT = 279,
-     TOK_ONLY = 280,
-     TOK_INCLUDE = 281,
-     TOK_SUBROUTINE = 282,
-     TOK_PROGRAM = 283,
-     TOK_FUNCTION = 284,
-     TOK_OMP = 285,
-     TOK_DOLLAR = 286,
-     TOK_FORMAT = 287,
-     TOK_MAX = 288,
-     TOK_TANH = 289,
-     TOK_WHERE = 290,
-     TOK_ELSEWHERE = 291,
-     TOK_ENDWHERE = 292,
-     TOK_MAXVAL = 293,
-     TOK_TRIM = 294,
-     TOK_SUM = 295,
-     TOK_SQRT = 296,
-     TOK_CASE = 297,
-     TOK_SELECTCASE = 298,
-     TOK_FILE = 299,
-     TOK_END = 300,
-     TOK_ERR = 301,
-     TOK_DONOTTREAT = 302,
-     TOK_ENDDONOTTREAT = 303,
-     TOK_EXIST = 304,
-     TOK_MIN = 305,
-     TOK_FLOAT = 306,
-     TOK_EXP = 307,
-     TOK_COS = 308,
-     TOK_COSH = 309,
-     TOK_ACOS = 310,
-     TOK_NINT = 311,
-     TOK_CYCLE = 312,
-     TOK_SIN = 313,
-     TOK_SINH = 314,
-     TOK_ASIN = 315,
-     TOK_EQUIVALENCE = 316,
-     TOK_BACKSPACE = 317,
-     TOK_LOG = 318,
-     TOK_TAN = 319,
-     TOK_ATAN = 320,
-     TOK_RECURSIVE = 321,
-     TOK_ABS = 322,
-     TOK_MOD = 323,
-     TOK_SIGN = 324,
-     TOK_MINLOC = 325,
-     TOK_MAXLOC = 326,
-     TOK_EXIT = 327,
-     TOK_MINVAL = 328,
-     TOK_PUBLIC = 329,
-     TOK_PRIVATE = 330,
-     TOK_ALLOCATABLE = 331,
-     TOK_RETURN = 332,
-     TOK_THEN = 333,
-     TOK_ELSEIF = 334,
-     TOK_ELSE = 335,
-     TOK_ENDIF = 336,
-     TOK_PRINT = 337,
-     TOK_PLAINGOTO = 338,
-     TOK_CONSTRUCTID = 339,
-     TOK_LOGICALIF = 340,
-     TOK_PLAINDO = 341,
-     TOK_CONTAINS = 342,
-     TOK_ENDDO = 343,
-     TOK_MODULE = 344,
-     TOK_ENDMODULE = 345,
-     TOK_DOWHILE = 346,
-     TOK_ALLOCATE = 347,
-     TOK_OPEN = 348,
-     TOK_CLOSE = 349,
-     TOK_INQUIRE = 350,
-     TOK_WRITE = 351,
-     TOK_READ = 352,
-     TOK_REWIND = 353,
-     TOK_DEALLOCATE = 354,
-     TOK_NULLIFY = 355,
-     TOK_FIN = 356,
-     TOK_DEBUT = 357,
-     TOK_DIMENSION = 358,
-     TOK_ENDSELECT = 359,
-     TOK_EXTERNAL = 360,
-     TOK_INTENT = 361,
-     TOK_INTRINSIC = 362,
-     TOK_NAMELIST = 363,
-     TOK_CASEDEFAULT = 364,
-     TOK_OPTIONAL = 365,
-     TOK_POINTER = 366,
-     TOK_CONTINUE = 367,
-     TOK_SAVE = 368,
-     TOK_TARGET = 369,
-     TOK_QUOTE = 370,
-     TOK_IMPLICIT = 371,
-     TOK_NONE = 372,
-     TOK_CALL = 373,
-     TOK_STAT = 374,
-     TOK_POINT_TO = 375,
-     TOK_COMMON = 376,
-     TOK_GLOBAL = 377,
-     TOK_INTERFACE = 378,
-     TOK_ENDINTERFACE = 379,
-     TOK_LEFTAB = 380,
-     TOK_RIGHTAB = 381,
-     TOK_PAUSE = 382,
-     TOK_PROCEDURE = 383,
-     TOK_STOP = 384,
-     TOK_NAMEEQ = 385,
-     TOK_REAL8 = 386,
-     TOK_OUT = 387,
-     TOK_INOUT = 388,
-     TOK_IN = 389,
-     TOK_USE = 390,
-     TOK_TRUE = 391,
-     TOK_FALSE = 392,
-     TOK_LABEL = 393,
-     TOK_TYPE = 394,
-     TOK_TYPEPAR = 395,
-     TOK_ENDTYPE = 396,
-     TOK_REAL = 397,
-     TOK_INTEGER = 398,
-     TOK_LOGICAL = 399,
-     TOK_DOUBLEPRECISION = 400,
-     TOK_DOUBLEREAL = 401,
-     TOK_ENDSUBROUTINE = 402,
-     TOK_ENDFUNCTION = 403,
-     TOK_ENDPROGRAM = 404,
-     TOK_ENDUNIT = 405,
-     TOK_CHARACTER = 406,
-     TOK_CHAR_CONSTANT = 407,
-     TOK_CHAR_CUT = 408,
-     TOK_DATA = 409,
-     TOK_CHAR_INT = 410,
-     TOK_CHAR_MESSAGE = 411,
-     TOK_CSTREAL = 412,
-     TOK_CSTREALDP = 413,
-     TOK_CSTREALQP = 414,
-     TOK_SFREAL = 415,
-     TOK_COMPLEX = 416,
-     TOK_DOUBLECOMPLEX = 417,
-     TOK_NAME = 418,
-     TOK_NAME_CHAR = 419,
-     TOK_PROBTYPE = 420,
-     TOK_INTERPTYPE = 421,
-     TOK_VARTYPE = 422,
-     TOK_BC = 423,
-     TOK_OP = 424,
-     TOK_CSTINT = 425,
-     TOK_COMMENT = 426,
-     TOK_FILENAME = 427
-   };
-#endif
-/* Tokens.  */
-#define TOK_BINARY_OP 258
-#define TOK_NEQV 259
-#define TOK_EQV 260
-#define TOK_XOR 261
-#define TOK_OR 262
-#define TOK_AND 263
-#define TOK_NOT 264
-#define TOK_NE 265
-#define TOK_EQ 266
-#define TOK_GE 267
-#define TOK_LE 268
-#define TOK_GT 269
-#define TOK_LT 270
-#define TOK_UNARY_OP 271
-#define TOK_DSLASH 272
-#define TOK_SLASH 273
-#define TOK_DASTER 274
-#define TOK_SEP 275
-#define TOK_SEMICOLON 276
-#define TOK_NEXTLINE 277
-#define TOK_PARAMETER 278
-#define TOK_RESULT 279
-#define TOK_ONLY 280
-#define TOK_INCLUDE 281
-#define TOK_SUBROUTINE 282
-#define TOK_PROGRAM 283
-#define TOK_FUNCTION 284
-#define TOK_OMP 285
-#define TOK_DOLLAR 286
-#define TOK_FORMAT 287
-#define TOK_MAX 288
-#define TOK_TANH 289
-#define TOK_WHERE 290
-#define TOK_ELSEWHERE 291
-#define TOK_ENDWHERE 292
-#define TOK_MAXVAL 293
-#define TOK_TRIM 294
-#define TOK_SUM 295
-#define TOK_SQRT 296
-#define TOK_CASE 297
-#define TOK_SELECTCASE 298
-#define TOK_FILE 299
-#define TOK_END 300
-#define TOK_ERR 301
-#define TOK_DONOTTREAT 302
-#define TOK_ENDDONOTTREAT 303
-#define TOK_EXIST 304
-#define TOK_MIN 305
-#define TOK_FLOAT 306
-#define TOK_EXP 307
-#define TOK_COS 308
-#define TOK_COSH 309
-#define TOK_ACOS 310
-#define TOK_NINT 311
-#define TOK_CYCLE 312
-#define TOK_SIN 313
-#define TOK_SINH 314
-#define TOK_ASIN 315
-#define TOK_EQUIVALENCE 316
-#define TOK_BACKSPACE 317
-#define TOK_LOG 318
-#define TOK_TAN 319
-#define TOK_ATAN 320
-#define TOK_RECURSIVE 321
-#define TOK_ABS 322
-#define TOK_MOD 323
-#define TOK_SIGN 324
-#define TOK_MINLOC 325
-#define TOK_MAXLOC 326
-#define TOK_EXIT 327
-#define TOK_MINVAL 328
-#define TOK_PUBLIC 329
-#define TOK_PRIVATE 330
-#define TOK_ALLOCATABLE 331
-#define TOK_RETURN 332
-#define TOK_THEN 333
-#define TOK_ELSEIF 334
-#define TOK_ELSE 335
-#define TOK_ENDIF 336
-#define TOK_PRINT 337
-#define TOK_PLAINGOTO 338
-#define TOK_CONSTRUCTID 339
-#define TOK_LOGICALIF 340
-#define TOK_PLAINDO 341
-#define TOK_CONTAINS 342
-#define TOK_ENDDO 343
-#define TOK_MODULE 344
-#define TOK_ENDMODULE 345
-#define TOK_DOWHILE 346
-#define TOK_ALLOCATE 347
-#define TOK_OPEN 348
-#define TOK_CLOSE 349
-#define TOK_INQUIRE 350
-#define TOK_WRITE 351
-#define TOK_READ 352
-#define TOK_REWIND 353
-#define TOK_DEALLOCATE 354
-#define TOK_NULLIFY 355
-#define TOK_FIN 356
-#define TOK_DEBUT 357
-#define TOK_DIMENSION 358
-#define TOK_ENDSELECT 359
-#define TOK_EXTERNAL 360
-#define TOK_INTENT 361
-#define TOK_INTRINSIC 362
-#define TOK_NAMELIST 363
-#define TOK_CASEDEFAULT 364
-#define TOK_OPTIONAL 365
-#define TOK_POINTER 366
-#define TOK_CONTINUE 367
-#define TOK_SAVE 368
-#define TOK_TARGET 369
-#define TOK_QUOTE 370
-#define TOK_IMPLICIT 371
-#define TOK_NONE 372
-#define TOK_CALL 373
-#define TOK_STAT 374
-#define TOK_POINT_TO 375
-#define TOK_COMMON 376
-#define TOK_GLOBAL 377
-#define TOK_INTERFACE 378
-#define TOK_ENDINTERFACE 379
-#define TOK_LEFTAB 380
-#define TOK_RIGHTAB 381
-#define TOK_PAUSE 382
-#define TOK_PROCEDURE 383
-#define TOK_STOP 384
-#define TOK_NAMEEQ 385
-#define TOK_REAL8 386
-#define TOK_OUT 387
-#define TOK_INOUT 388
-#define TOK_IN 389
-#define TOK_USE 390
-#define TOK_TRUE 391
-#define TOK_FALSE 392
-#define TOK_LABEL 393
-#define TOK_TYPE 394
-#define TOK_TYPEPAR 395
-#define TOK_ENDTYPE 396
-#define TOK_REAL 397
-#define TOK_INTEGER 398
-#define TOK_LOGICAL 399
-#define TOK_DOUBLEPRECISION 400
-#define TOK_DOUBLEREAL 401
-#define TOK_ENDSUBROUTINE 402
-#define TOK_ENDFUNCTION 403
-#define TOK_ENDPROGRAM 404
-#define TOK_ENDUNIT 405
-#define TOK_CHARACTER 406
-#define TOK_CHAR_CONSTANT 407
-#define TOK_CHAR_CUT 408
-#define TOK_DATA 409
-#define TOK_CHAR_INT 410
-#define TOK_CHAR_MESSAGE 411
-#define TOK_CSTREAL 412
-#define TOK_CSTREALDP 413
-#define TOK_CSTREALQP 414
-#define TOK_SFREAL 415
-#define TOK_COMPLEX 416
-#define TOK_DOUBLECOMPLEX 417
-#define TOK_NAME 418
-#define TOK_NAME_CHAR 419
-#define TOK_PROBTYPE 420
-#define TOK_INTERPTYPE 421
-#define TOK_VARTYPE 422
-#define TOK_BC 423
-#define TOK_OP 424
-#define TOK_CSTINT 425
-#define TOK_COMMENT 426
-#define TOK_FILENAME 427
-
-
-
+#define yyparse         fortran_parse
+#define yylex           fortran_lex
+#define yyerror         fortran_error
+#define yylval          fortran_lval
+#define yychar          fortran_char
+#define yydebug         fortran_debug
+#define yynerrs         fortran_nerrs
 
 /* Copy the first part of user declarations.  */
+/* Line 371 of yacc.c  */
 #line 36 "fortran.y"
 
@@ -430,25 +77,36 @@
 #include <string.h>
 #include "decl.h"
-extern int line_num_fortran;
-extern int line_num_fortran_common;
-char *tmp;
-char c_selectorname[LONG_C];
-char ligne[LONG_C];
-char truename[LONGNOM];
-char identcopy[LONG_C];
+
+extern int line_num_input;
+extern char *fortran_text;
+
+char c_selectorname[LONG_M];
+char ligne[LONG_M];
+char truename[LONG_VNAME];
+char identcopy[LONG_VNAME];
 int c_selectorgiven=0;
-int incom;
 listvar *curlistvar;
 typedim c_selectordim;
 listcouple *coupletmp;
-listdim *parcoursdim;
 int removeline=0;
 listvar *test;
 
-
-/* Enabling traces.  */
-#ifndef YYDEBUG
-# define YYDEBUG 0
-#endif
+int fortran_error(const char *s)
+{
+    printf("%s line %d, file %s motclef = |%s|\n", s, line_num_input, cur_filename, fortran_text);
+    exit(1);
+}
+
+
+/* Line 371 of yacc.c  */
+#line 104 "fortran.tab.c"
+
+# ifndef YY_NULL
+#  if defined __cplusplus && 201103L <= __cplusplus
+#   define YY_NULL nullptr
+#  else
+#   define YY_NULL 0
+#  endif
+# endif
 
 /* Enabling verbose error messages.  */
@@ -460,38 +118,221 @@
 #endif
 
-/* Enabling the token table.  */
-#ifndef YYTOKEN_TABLE
-# define YYTOKEN_TABLE 0
+
+/* Enabling traces.  */
+#ifndef YYDEBUG
+# define YYDEBUG 1
 #endif
+#if YYDEBUG
+extern int fortran_debug;
+#endif
+
+/* Tokens.  */
+#ifndef YYTOKENTYPE
+# define YYTOKENTYPE
+   /* Put the tokens into the symbol table, so that GDB and other debuggers
+      know about them.  */
+   enum yytokentype {
+     TOK_NEQV = 258,
+     TOK_EQV = 259,
+     TOK_XOR = 260,
+     TOK_OR = 261,
+     TOK_AND = 262,
+     TOK_NOT = 263,
+     TOK_NE = 264,
+     TOK_EQ = 265,
+     TOK_GE = 266,
+     TOK_LE = 267,
+     TOK_GT = 268,
+     TOK_LT = 269,
+     TOK_DSLASH = 270,
+     TOK_SLASH = 271,
+     TOK_DASTER = 272,
+     TOK_SEMICOLON = 273,
+     TOK_PARAMETER = 274,
+     TOK_RESULT = 275,
+     TOK_ONLY = 276,
+     TOK_INCLUDE = 277,
+     TOK_SUBROUTINE = 278,
+     TOK_PROGRAM = 279,
+     TOK_FUNCTION = 280,
+     TOK_FORMAT = 281,
+     TOK_MAX = 282,
+     TOK_TANH = 283,
+     TOK_WHERE = 284,
+     TOK_ELSEWHEREPAR = 285,
+     TOK_ELSEWHERE = 286,
+     TOK_ENDWHERE = 287,
+     TOK_MAXVAL = 288,
+     TOK_TRIM = 289,
+     TOK_NULL_PTR = 290,
+     TOK_SUM = 291,
+     TOK_SQRT = 292,
+     TOK_CASE = 293,
+     TOK_SELECTCASE = 294,
+     TOK_FILE = 295,
+     TOK_UNIT = 296,
+     TOK_FMT = 297,
+     TOK_NML = 298,
+     TOK_END = 299,
+     TOK_EOR = 300,
+     TOK_ERR = 301,
+     TOK_EXIST = 302,
+     TOK_MIN = 303,
+     TOK_FLOAT = 304,
+     TOK_EXP = 305,
+     TOK_COS = 306,
+     TOK_COSH = 307,
+     TOK_ACOS = 308,
+     TOK_NINT = 309,
+     TOK_CYCLE = 310,
+     TOK_SIN = 311,
+     TOK_SINH = 312,
+     TOK_ASIN = 313,
+     TOK_EQUIVALENCE = 314,
+     TOK_BACKSPACE = 315,
+     TOK_LOG = 316,
+     TOK_TAN = 317,
+     TOK_ATAN = 318,
+     TOK_RECURSIVE = 319,
+     TOK_ABS = 320,
+     TOK_MOD = 321,
+     TOK_SIGN = 322,
+     TOK_MINLOC = 323,
+     TOK_MAXLOC = 324,
+     TOK_EXIT = 325,
+     TOK_MINVAL = 326,
+     TOK_PUBLIC = 327,
+     TOK_PRIVATE = 328,
+     TOK_ALLOCATABLE = 329,
+     TOK_RETURN = 330,
+     TOK_THEN = 331,
+     TOK_ELSEIF = 332,
+     TOK_ELSE = 333,
+     TOK_ENDIF = 334,
+     TOK_PRINT = 335,
+     TOK_PLAINGOTO = 336,
+     TOK_LOGICALIF = 337,
+     TOK_PLAINDO = 338,
+     TOK_CONTAINS = 339,
+     TOK_ENDDO = 340,
+     TOK_MODULE = 341,
+     TOK_ENDMODULE = 342,
+     TOK_WHILE = 343,
+     TOK_CONCURRENT = 344,
+     TOK_ALLOCATE = 345,
+     TOK_OPEN = 346,
+     TOK_CLOSE = 347,
+     TOK_INQUIRE = 348,
+     TOK_WRITE = 349,
+     TOK_FLUSH = 350,
+     TOK_READ = 351,
+     TOK_REWIND = 352,
+     TOK_DEALLOCATE = 353,
+     TOK_NULLIFY = 354,
+     TOK_DIMENSION = 355,
+     TOK_ENDSELECT = 356,
+     TOK_EXTERNAL = 357,
+     TOK_INTENT = 358,
+     TOK_INTRINSIC = 359,
+     TOK_NAMELIST = 360,
+     TOK_DEFAULT = 361,
+     TOK_OPTIONAL = 362,
+     TOK_POINTER = 363,
+     TOK_CONTINUE = 364,
+     TOK_SAVE = 365,
+     TOK_TARGET = 366,
+     TOK_IMPLICIT = 367,
+     TOK_NONE = 368,
+     TOK_CALL = 369,
+     TOK_STAT = 370,
+     TOK_POINT_TO = 371,
+     TOK_COMMON = 372,
+     TOK_GLOBAL = 373,
+     TOK_LEFTAB = 374,
+     TOK_RIGHTAB = 375,
+     TOK_PAUSE = 376,
+     TOK_PROCEDURE = 377,
+     TOK_STOP = 378,
+     TOK_REAL8 = 379,
+     TOK_FOURDOTS = 380,
+     TOK_HEXA = 381,
+     TOK_ASSIGNTYPE = 382,
+     TOK_OUT = 383,
+     TOK_INOUT = 384,
+     TOK_IN = 385,
+     TOK_USE = 386,
+     TOK_TRUE = 387,
+     TOK_FALSE = 388,
+     TOK_LABEL = 389,
+     TOK_TYPE = 390,
+     TOK_TYPEPAR = 391,
+     TOK_ENDTYPE = 392,
+     TOK_REAL = 393,
+     TOK_INTEGER = 394,
+     TOK_LOGICAL = 395,
+     TOK_DOUBLEPRECISION = 396,
+     TOK_ENDSUBROUTINE = 397,
+     TOK_ENDFUNCTION = 398,
+     TOK_ENDPROGRAM = 399,
+     TOK_ENDUNIT = 400,
+     TOK_CHARACTER = 401,
+     TOK_CHAR_CONSTANT = 402,
+     TOK_CHAR_CUT = 403,
+     TOK_DATA = 404,
+     TOK_CHAR_MESSAGE = 405,
+     TOK_CSTREAL = 406,
+     TOK_COMPLEX = 407,
+     TOK_DOUBLECOMPLEX = 408,
+     TOK_NAME = 409,
+     TOK_CSTINT = 410
+   };
+#endif
+
 
 #if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
 typedef union YYSTYPE
-#line 59 "fortran.y"
 {
-       char      nac[LONG_C];
-       char      na[LONGNOM];
-       listdim  *d;
-       listvar  *l;
-       listnom  *ln;
-       listcouple  *lc;
-       listname *lnn;
-       typedim   dim1;
-       variable *v;
-       }
-/* Line 193 of yacc.c.  */
-#line 483 "fortran.tab.c"
-	YYSTYPE;
+/* Line 387 of yacc.c  */
+#line 65 "fortran.y"
+
+    char        na[LONG_M];
+    listdim     *d;
+    listvar     *l;
+    listcouple  *lc;
+    listname    *lnn;
+    typedim     dim1;
+    variable    *v;
+
+
+/* Line 387 of yacc.c  */
+#line 310 "fortran.tab.c"
+} YYSTYPE;
+# define YYSTYPE_IS_TRIVIAL 1
 # define yystype YYSTYPE /* obsolescent; will be withdrawn */
 # define YYSTYPE_IS_DECLARED 1
-# define YYSTYPE_IS_TRIVIAL 1
 #endif
 
+extern YYSTYPE fortran_lval;
+
+#ifdef YYPARSE_PARAM
+#if defined __STDC__ || defined __cplusplus
+int fortran_parse (void *YYPARSE_PARAM);
+#else
+int fortran_parse ();
+#endif
+#else /* ! YYPARSE_PARAM */
+#if defined __STDC__ || defined __cplusplus
+int fortran_parse (void);
+#else
+int fortran_parse ();
+#endif
+#endif /* ! YYPARSE_PARAM */
+
 
 
 /* Copy the second part of user declarations.  */
 
-
-/* Line 216 of yacc.c.  */
-#line 496 "fortran.tab.c"
+/* Line 390 of yacc.c  */
+#line 338 "fortran.tab.c"
 
 #ifdef short
@@ -546,9 +387,9 @@
 #  if ENABLE_NLS
 #   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
-#   define YY_(msgid) dgettext ("bison-runtime", msgid)
+#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
 #  endif
 # endif
 # ifndef YY_
-#  define YY_(msgid) msgid
+#  define YY_(Msgid) Msgid
 # endif
 #endif
@@ -556,24 +397,24 @@
 /* Suppress unused-variable warnings by "using" E.  */
 #if ! defined lint || defined __GNUC__
-# define YYUSE(e) ((void) (e))
+# define YYUSE(E) ((void) (E))
 #else
-# define YYUSE(e) /* empty */
+# define YYUSE(E) /* empty */
 #endif
 
 /* Identity function, used to suppress warnings about constant conditions.  */
 #ifndef lint
-# define YYID(n) (n)
+# define YYID(N) (N)
 #else
 #if (defined __STDC__ || defined __C99__FUNC__ \
      || defined __cplusplus || defined _MSC_VER)
 static int
-YYID (int i)
+YYID (int yyi)
 #else
 static int
-YYID (i)
-    int i;
+YYID (yyi)
+    int yyi;
 #endif
 {
-  return i;
+  return yyi;
 }
 #endif
@@ -596,9 +437,10 @@
 #   else
 #    define YYSTACK_ALLOC alloca
-#    if ! defined _ALLOCA_H && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
+#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
      || defined __cplusplus || defined _MSC_VER)
 #     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
-#     ifndef _STDLIB_H
-#      define _STDLIB_H 1
+      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
+#     ifndef EXIT_SUCCESS
+#      define EXIT_SUCCESS 0
 #     endif
 #    endif
@@ -623,15 +465,15 @@
 #   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
 #  endif
-#  if (defined __cplusplus && ! defined _STDLIB_H \
+#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
        && ! ((defined YYMALLOC || defined malloc) \
 	     && (defined YYFREE || defined free)))
 #   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
-#   ifndef _STDLIB_H
-#    define _STDLIB_H 1
+#   ifndef EXIT_SUCCESS
+#    define EXIT_SUCCESS 0
 #   endif
 #  endif
 #  ifndef YYMALLOC
 #   define YYMALLOC malloc
-#   if ! defined malloc && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
+#   if ! defined malloc && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
      || defined __cplusplus || defined _MSC_VER)
 void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
@@ -640,5 +482,5 @@
 #  ifndef YYFREE
 #   define YYFREE free
-#   if ! defined free && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
+#   if ! defined free && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
      || defined __cplusplus || defined _MSC_VER)
 void free (void *); /* INFRINGES ON USER NAME SPACE */
@@ -656,7 +498,7 @@
 union yyalloc
 {
-  yytype_int16 yyss;
-  YYSTYPE yyvs;
-  };
+  yytype_int16 yyss_alloc;
+  YYSTYPE yyvs_alloc;
+};
 
 /* The size of the maximum gap between one aligned stack and the next.  */
@@ -669,21 +511,5 @@
       + YYSTACK_GAP_MAXIMUM)
 
-/* Copy COUNT objects from FROM to TO.  The source and destination do
-   not overlap.  */
-# ifndef YYCOPY
-#  if defined __GNUC__ && 1 < __GNUC__
-#   define YYCOPY(To, From, Count) \
-      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
-#  else
-#   define YYCOPY(To, From, Count)		\
-      do					\
-	{					\
-	  YYSIZE_T yyi;				\
-	  for (yyi = 0; yyi < (Count); yyi++)	\
-	    (To)[yyi] = (From)[yyi];		\
-	}					\
-      while (YYID (0))
-#  endif
-# endif
+# define YYCOPY_NEEDED 1
 
 /* Relocate STACK from its old location to the new one.  The
@@ -692,10 +518,10 @@
    stack.  Advance YYPTR to a properly aligned location for the next
    stack.  */
-# define YYSTACK_RELOCATE(Stack)					\
+# define YYSTACK_RELOCATE(Stack_alloc, Stack)				\
     do									\
       {									\
 	YYSIZE_T yynewbytes;						\
-	YYCOPY (&yyptr->Stack, Stack, yysize);				\
-	Stack = &yyptr->Stack;						\
+	YYCOPY (&yyptr->Stack_alloc, Stack, yysize);			\
+	Stack = &yyptr->Stack_alloc;					\
 	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
 	yyptr += yynewbytes / sizeof (*yyptr);				\
@@ -705,21 +531,41 @@
 #endif
 
+#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
+/* Copy COUNT objects from SRC to DST.  The source and destination do
+   not overlap.  */
+# ifndef YYCOPY
+#  if defined __GNUC__ && 1 < __GNUC__
+#   define YYCOPY(Dst, Src, Count) \
+      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
+#  else
+#   define YYCOPY(Dst, Src, Count)              \
+      do                                        \
+        {                                       \
+          YYSIZE_T yyi;                         \
+          for (yyi = 0; yyi < (Count); yyi++)   \
+            (Dst)[yyi] = (Src)[yyi];            \
+        }                                       \
+      while (YYID (0))
+#  endif
+# endif
+#endif /* !YYCOPY_NEEDED */
+
 /* YYFINAL -- State number of the termination state.  */
 #define YYFINAL  2
 /* YYLAST -- Last index in YYTABLE.  */
-#define YYLAST   6070
+#define YYLAST   6268
 
 /* YYNTOKENS -- Number of terminals.  */
-#define YYNTOKENS  190
+#define YYNTOKENS  169
 /* YYNNTS -- Number of nonterminals.  */
-#define YYNNTS  184
+#define YYNNTS  206
 /* YYNRULES -- Number of rules.  */
-#define YYNRULES  555
+#define YYNRULES  597
 /* YYNRULES -- Number of states.  */
-#define YYNSTATES  982
+#define YYNSTATES  1051
 
 /* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
 #define YYUNDEFTOK  2
-#define YYMAXUTOK   427
+#define YYMAXUTOK   410
 
 #define YYTRANSLATE(YYX)						\
@@ -730,13 +576,13 @@
 {
        0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
-     187,     2,     2,     2,     2,     2,     2,     2,     2,     2,
+     166,     2,     2,     2,     2,     2,     2,     2,     2,     2,
        2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
-       2,     2,     2,   183,     2,     2,     2,   189,     2,     2,
-     179,   180,    23,    21,     3,    22,     2,   188,     2,     2,
+       2,     2,     2,     2,     2,     2,     2,   168,     2,     2,
+     162,   163,    21,    19,     3,    20,     2,   167,     2,     2,
        2,     2,     2,     2,     2,     2,     2,     2,     4,     2,
-     185,     5,   186,     2,     2,     2,     2,     2,     2,     2,
+     164,     5,   165,     2,     2,     2,     2,     2,     2,     2,
        2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
        2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
-       2,   181,     2,   182,     2,   184,     2,     2,     2,     2,
+       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
        2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
        2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
@@ -756,5 +602,5 @@
        2,     2,     2,     2,     2,     2,     1,     2,     6,     7,
        8,     9,    10,    11,    12,    13,    14,    15,    16,    17,
-      18,    19,    20,    24,    25,    26,    27,    28,    29,    30,
+      18,    22,    23,    24,    25,    26,    27,    28,    29,    30,
       31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
       41,    42,    43,    44,    45,    46,    47,    48,    49,    50,
@@ -770,6 +616,5 @@
      141,   142,   143,   144,   145,   146,   147,   148,   149,   150,
      151,   152,   153,   154,   155,   156,   157,   158,   159,   160,
-     161,   162,   163,   164,   165,   166,   167,   168,   169,   170,
-     171,   172,   173,   174,   175,   176,   177,   178
+     161
 };
 
